Bug 1327176 - Review Request: fabtests - Test suite for libfabric API
Summary: Review Request: fabtests - Test suite for libfabric API
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Michal Schmidt
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1315609
TreeView+ depends on / blocked
 
Reported: 2016-04-14 12:08 UTC by Honggang LI
Modified: 2016-05-07 12:03 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-05-07 12:03:50 UTC
mschmidt: fedora-review+


Attachments (Terms of Use)
[PATCH] adjust shebang lines in rft_yaml_to_junit_xml and runfabtests.sh (1.05 KB, patch)
2016-04-19 12:04 UTC, Michal Schmidt
no flags Details | Diff

Description Honggang LI 2016-04-14 12:08:47 UTC
Spec URL: http://people.redhat.com/honli/.6c4263a86d3cd6fa84aba6f0abab9269/fabtests.spec

SRPM URL: http://people.redhat.com/honli/.6c4263a86d3cd6fa84aba6f0abab9269/fabtests-1.3.0-1.fc25.src.rpm

Description: Fabtests provides a set of examples that uses libfabric - a high-performance fabric software library.

Fedora Account System Username: honli

Comment 1 Michal Schmidt 2016-04-14 12:16:34 UTC
> %files
> # All fires are licensed as GPLv2.

Misleading comment, please remove.

> %dir %{_datadir}/%{name}/
> %{_datadir}/%{name}/*

Since you're owning the directory and all of its contents,
the two lines can be simplified to one:
%{_datadir}/%{name}

Comment 3 Honggang LI 2016-04-17 13:15:48 UTC
Michal
 I had updated the spec and srpm. Please review.

Comment 4 Michal Schmidt 2016-04-18 14:27:02 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
To be very precise, the License tag should say:
License: BSD and (BSD or GPLv2) and MIT
Since the Guidelines requires us to describe multiple-licensing scenarios,
I suggest to put a comment above the License header:
# include/jsmn.h and common/jsmn.c are licensed under MIT.
# All other source files permit distribution under BSD. Some of them
# additionaly expressly allow the option to be licensed under GPLv2.
# See the license headers in individual source files to see which those are.

/usr/bin/rft_yaml_to_junit_xml starts with:
  #!/usr/bin/env ruby
Looks like the package should Require ruby?
I don't know if rft_yaml_to_junit_xml is an important part of the package.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
#### Some source files specify only the BSD license. Other source files say
     we can choose BSD or GPLv2. jsmn.[ch] carry the MIT license.
     Distributing the whole under BSD or GPLv2 is permitted.
     Though to be very precise, the License tag should say:
     BSD and (BSD or GPLv2) and MIT
     https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Mixed_Source_Licensing_Scenario

The following source files are under the BSD license:
./complex/ft_msg.c
./complex/ft_comp.c
./complex/ft_domain.c
./complex/fabtest.h
./complex/ft_config.c
./complex/ft_test.c
./complex/ft_main.c
./complex/ft_endpoint.c
./complex/ft_comm.c
./simple/poll.c
./simple/dgram_waitset.c
./simple/rdm_shared_ctx.c
./simple/rdm_tagged_peek.c
./simple/rdm.c
./simple/msg_epoll.c
./simple/scalable_ep.c
./simple/rdm_shared_av.c
./simple/rdm_rma_trigger.c
./simple/msg_sockets.c
./simple/cq_data.c
./simple/rdm_rma_simple.c
./simple/msg.c
./simple/dgram.c
./benchmarks/rdm_tagged_pingpong.c
./benchmarks/msg_pingpong.c
./benchmarks/rdm_pingpong.c
./benchmarks/rdm_cntr_pingpong.c
./benchmarks/rdm_tagged_bw.c
./include/shared.h
./streaming/rdm_rma.c
./streaming/rdm_atomic.c
./streaming/rdm_multi_recv.c
./streaming/msg_rma.c
./common/shared.c

The following source files are under BSD or GPLv2:
./ported/libibverbs/rc_pingpong.c
./ported/librdmacm/cmatose.c
./benchmarks/dgram_pingpong.c
./benchmarks/benchmark_shared.c
./benchmarks/benchmark_shared.h
./include/osx/osd.h
./include/unit_common.h
./common/osx/osd.c
./unit/size_left_test.c
./unit/common.c
./unit/eq_test.c
./unit/dom_test.c
./unit/av_test.c

The following files are under the MIT license:
./include/jsmn.h
./common/jsmn.c

[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: fabtests-1.3.0-2.fc25.x86_64.rpm
          fabtests-debuginfo-1.3.0-2.fc25.x86_64.rpm
          fabtests-1.3.0-2.fc25.src.rpm
fabtests.x86_64: W: spelling-error Summary(en_US) libfabric -> lib fabric, lib-fabric, fabric
fabtests.x86_64: W: spelling-error %description -l en_US libfabric -> lib fabric, lib-fabric, fabric
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_atomic
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_rma_simple
fabtests.x86_64: W: no-manual-page-for-binary fi_msg_rma
fabtests.x86_64: W: no-manual-page-for-binary fi_dgram
fabtests.x86_64: W: no-manual-page-for-binary fi_msg_epoll
fabtests.x86_64: W: no-manual-page-for-binary fi_msg
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm
fabtests.x86_64: W: no-manual-page-for-binary fi_msg_pingpong
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_tagged_peek
fabtests.x86_64: W: no-manual-page-for-binary fi_dom_test
fabtests.x86_64: W: no-manual-page-for-binary fi_av_test
fabtests.x86_64: W: no-manual-page-for-binary fi_dgram_pingpong
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_shared_av
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_rma
fabtests.x86_64: W: no-manual-page-for-binary fi_size_left_test
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_tagged_pingpong
fabtests.x86_64: W: no-manual-page-for-binary fi_dgram_waitset
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_cntr_pingpong
fabtests.x86_64: W: no-manual-page-for-binary fi_scalable_ep
fabtests.x86_64: W: no-manual-page-for-binary runfabtests.sh
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_rma_trigger
fabtests.x86_64: W: no-manual-page-for-binary fi_cmatose
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_shared_ctx
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_tagged_bw
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_multi_recv
fabtests.x86_64: W: no-manual-page-for-binary fi_rdm_pingpong
fabtests.x86_64: W: no-manual-page-for-binary fi_msg_sockets
fabtests.x86_64: W: no-manual-page-for-binary fi_eq_test
fabtests.x86_64: W: no-manual-page-for-binary rft_yaml_to_junit_xml
fabtests.x86_64: W: no-manual-page-for-binary fi_rc_pingpong
fabtests.x86_64: W: no-manual-page-for-binary fi_poll
fabtests.x86_64: W: no-manual-page-for-binary fi_ubertest
fabtests.x86_64: W: no-manual-page-for-binary fi_cq_data
fabtests.src: W: spelling-error Summary(en_US) libfabric -> lib fabric, lib-fabric, fabric
fabtests.src: W: spelling-error %description -l en_US libfabric -> lib fabric, lib-fabric, fabric
fabtests.src: W: invalid-url Source0: https://github.com/ofiwg/fabtests/releases/download/v1.3.0/fabtests-1.3.0.tar.bz2 HTTP Error 403: Forbidden
3 packages and 0 specfiles checked; 0 errors, 38 warnings.




Requires
--------
fabtests (rpmlib, GLIBC filtered):
    /usr/bin/env
    libc.so.6()(64bit)
    libfabric.so.1()(64bit)
    libfabric.so.1(FABRIC_1.0)(64bit)
    rtld(GNU_HASH)

fabtests-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
fabtests:
    fabtests
    fabtests(x86-64)

fabtests-debuginfo:
    fabtests-debuginfo
    fabtests-debuginfo(x86-64)



Source checksums
----------------
https://github.com/ofiwg/fabtests/releases/download/v1.3.0/fabtests-1.3.0.tar.bz2 :
  CHECKSUM(SHA256) this package     : 5e137c76b992cf6aba40b7ada826edd803535bb4c621e7f6fd4a8af12a313d9f
  CHECKSUM(SHA256) upstream package : 5e137c76b992cf6aba40b7ada826edd803535bb4c621e7f6fd4a8af12a313d9f


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1327176
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 5 Honggang LI 2016-04-19 09:30:37 UTC
diff -up fabtests.spec.old fabtests.spec
--- fabtests.spec.old   2016-04-17 09:13:57.000000000 -0400
+++ fabtests.spec       2016-04-19 03:57:28.266508422 -0400
@@ -1,13 +1,18 @@
 Name:           fabtests
 Version:        1.3.0
-Release:        2%{?dist}
+Release:        3%{?dist}
 Summary:        Test suite for libfabric API
-License:        GPLv2 or BSD
+# include/jsmn.h and common/jsmn.c are licensed under MIT.
+# All other source files permit distribution under BSD. Some of them
+# additionaly expressly allow the option to be licensed under GPLv2.
+# See the license headers in individual source files to see which those are.
+License:        BSD and (BSD or GPLv2) and MIT
 Url:            https://github.com/ofiwg/fabtests
 Source:         https://github.com/ofiwg/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.bz2
 BuildRequires:  libfabric-devel >= 1.3.0
 BuildRequires:  valgrind-devel
 BuildRequires:  gcc
+Requires:       ruby
 
 %description
 Fabtests provides a set of examples that uses libfabric - a high-performance
@@ -33,6 +38,10 @@ rm -f %{buildroot}%{_libdir}/*.la
 %license COPYING
 
 %changelog
+* Tue Apr 19 2016 Honggang Li <honli@redhat.com> - 1.3.0-3
+- Provide precise license information.
+- Require ruby.
+
 * Thu Apr 14 2016 Honggang Li <honli@redhat.com> - 1.3.0-2
 - Remove license comment in file section.
 - Merge duplicated file entries.

Comment 7 Michal Schmidt 2016-04-19 12:04:11 UTC
Created attachment 1148539 [details]
[PATCH] adjust shebang lines in rft_yaml_to_junit_xml and runfabtests.sh

> Requires: ruby

I'm not sure that's even the correct package name to require. /usr/bin/ruby is provided by a package called "rubypick", which in turn pulls in one of the Ruby implementations.

I think a better way to get the dependencies right is to patch the scripts to avoid using /usr/bin/env in shebang lines ("#!/usr/bin/env bash" looks particularly silly, but I understand upstream tries wants to be compatible with non-Linux systems). Then rpmbuild will be able to record the dependency on the script interpreter and you won't have to have an explicit Requires.

Suggested patch to apply as %patch1 attached.

Comment 8 Michal Schmidt 2016-04-19 12:06:06 UTC
Anyway, I don't think the current way is against the packaging guidelines, so I approve the package.
If you agree with my proposal in comment #7, add the patch before importing.

Comment 9 Gwyn Ciesla 2016-04-19 12:56:24 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/fabtests

Comment 10 Honggang LI 2016-04-19 13:00:42 UTC
$rpm -qpR fabtests-1.3.0-3.fc25.x86_64.rpm | grep bin
/bin/bash
/usr/bin/ruby

Thanks for the patch. I will apply it and remove 'Requires: ruby', as it is unnecessary.

Comment 11 Fedora Update System 2016-04-19 13:23:23 UTC
fabtests-1.3.0-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-0264e64287

Comment 12 Fedora Update System 2016-04-19 20:24:36 UTC
fabtests-1.3.0-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-0264e64287

Comment 13 Fedora Update System 2016-05-07 12:03:48 UTC
fabtests-1.3.0-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.